#ifndef PINS_H
#define PINS_H

#define X_MS1_PIN -1
#define X_MS2_PIN -1
#define Y_MS1_PIN -1
#define Y_MS2_PIN -1
#define Z_MS1_PIN -1
#define Z_MS2_PIN -1
#define E0_MS1_PIN -1
#define E0_MS2_PIN -1
#define E1_MS1_PIN -1
#define E1_MS2_PIN -1
#define DIGIPOTSS_PIN -1


/****************************************************************************************
* Arduino Mega pin assignment
*
****************************************************************************************/
#if MOTHERBOARD == 33 || MOTHERBOARD == 34
#define KNOWN_BOARD 1

//////////////////FIX THIS//////////////
#ifndef __AVR_ATmega1280__
 #ifndef __AVR_ATmega2560__
 #error Oops!  Make sure you have 'Arduino Mega' selected from the 'Tools -> Boards' menu.
 #endif
#endif

#if MOTHERBOARD == 33 || MOTHERBOARD == 34 

  #define LARGE_FLASH true

  #define X_STEP_PIN         37 
  #define X_DIR_PIN          40 
  #define X_ENABLE_PIN       36 
  #define X_MIN_PIN          41 
  #define X_MAX_PIN          18 

  #define Y_STEP_PIN         20 
  #define Y_DIR_PIN          21
  #define Y_ENABLE_PIN       19 
  #define Y_MIN_PIN          42 
  #define Y_MAX_PIN          43 

  #define Z_STEP_PIN         45 
  #define Z_DIR_PIN          46 
  #define Z_ENABLE_PIN       44 
  #define Z_MIN_PIN          47 
  #define Z_MAX_PIN          48 



  #define E0_STEP_PIN        57 
  #define E0_DIR_PIN         58 
  #define E0_ENABLE_PIN      56 

  #define E1_STEP_PIN        60 
  #define E1_DIR_PIN         61 
  #define E1_ENABLE_PIN      59 
  
  #define E2_STEP_PIN        23 
  #define E2_DIR_PIN         24 
  #define E2_ENABLE_PIN      22 

  #define SDPOWER            -1
  #define SDSS               53
  #define LED_PIN            13 //ok
  
  #define PS_ON_PIN          55
  #define KILL_PIN           -1 
  
  #define HEATER_0_PIN       9  //ok 
  #define HEATER_1_PIN       8  //ok 
  #define HEATER_2_PIN       7  //ok 
  
  #define TEMP_0_PIN         12 //ok
  #define TEMP_1_PIN         13 //ok
  #define TEMP_2_PIN         14 //ok 
  #define TEMP_BED_PIN       15 //ok
   
  #define HEATER_BED_PIN     6  //ok 
  
  #define FAN_PIN            10 //ok

  #define SERVO0_PIN         3
  #define SERVO1_PIN         2
  #define SERVO2_PIN         5
  #define SERVO3_PIN         4

//PinOut LCD
  #ifdef ULTRA_LCD
    #ifdef NEWPANEL
      #define LCD_PINS_RS 29
      #define LCD_PINS_ENABLE 39
      #define LCD_PINS_D4 28
      #define LCD_PINS_D5 27
      #define LCD_PINS_D6 26
      #define LCD_PINS_D7 25
      #define BEEPER  15 
      #define BTN_EN1 17
      #define BTN_EN2 16
      #define BTN_ENC 14 
      #define SDCARDDETECT -1 //49 CLONEBOT
    #endif
  #endif //ULTRA_LCD
#endif // MOTHERBOARD == 33 || MOTHERBOARD == 34 

#ifndef SDSUPPORT
// these pins are defined in the SD library if building with SD support
  #define MAX_SCK_PIN          52
  #define MAX_MISO_PIN         50
  #define MAX_MOSI_PIN         51
  #define MAX6675_SS           53
#endif

#endif //MOTHERBOARD == 33 || MOTHERBOARD == 34


/****************************************************************************************
*                             ELECTRONICA DESCONOCIDA
*
****************************************************************************************/
#ifndef KNOWN_BOARD
#error Unknown MOTHERBOARD value in configuration.h
#endif

//List of pins which to ignore when asked to change by gcode, 0 and 1 are RX and TX, do not mess with those!
#define _E0_PINS E0_STEP_PIN, E0_DIR_PIN, E0_ENABLE_PIN, HEATER_0_PIN,
#if EXTRUDERS > 1
  #define _E1_PINS E1_STEP_PIN, E1_DIR_PIN, E1_ENABLE_PIN, HEATER_1_PIN,
#else
  #define _E1_PINS
#endif
#if EXTRUDERS > 2
  #define _E2_PINS E2_STEP_PIN, E2_DIR_PIN, E2_ENABLE_PIN, HEATER_2_PIN,
#else
  #define _E2_PINS
#endif

#ifdef X_STOP_PIN
  #if X_HOME_DIR < 0
    #define X_MIN_PIN X_STOP_PIN
    #define X_MAX_PIN -1
  #else
    #define X_MIN_PIN -1
    #define X_MAX_PIN X_STOP_PIN
  #endif
#endif

#ifdef Y_STOP_PIN
  #if Y_HOME_DIR < 0
    #define Y_MIN_PIN Y_STOP_PIN
    #define Y_MAX_PIN -1
  #else
    #define Y_MIN_PIN -1
    #define Y_MAX_PIN Y_STOP_PIN
  #endif
#endif

#ifdef Z_STOP_PIN
  #if Z_HOME_DIR < 0
    #define Z_MIN_PIN Z_STOP_PIN
    #define Z_MAX_PIN -1
  #else
    #define Z_MIN_PIN -1
    #define Z_MAX_PIN Z_STOP_PIN
  #endif
#endif

#ifdef DISABLE_MAX_ENDSTOPS
#define X_MAX_PIN          -1
#define Y_MAX_PIN          -1
#define Z_MAX_PIN          -1
#endif

#ifdef DISABLE_MIN_ENDSTOPS
#define X_MIN_PIN          -1
#define Y_MIN_PIN          -1
#define Z_MIN_PIN          -1
#endif

#define SENSITIVE_PINS {0, 1, X_STEP_PIN, X_DIR_PIN, X_ENABLE_PIN, X_MIN_PIN, X_MAX_PIN, Y_STEP_PIN, Y_DIR_PIN, Y_ENABLE_PIN, Y_MIN_PIN, Y_MAX_PIN, Z_STEP_PIN, Z_DIR_PIN, Z_ENABLE_PIN, Z_MIN_PIN, Z_MAX_PIN, PS_ON_PIN, \
                        HEATER_BED_PIN, FAN_PIN,                  \
                        _E0_PINS _E1_PINS _E2_PINS             \
                        analogInputToDigitalPin(TEMP_0_PIN), analogInputToDigitalPin(TEMP_1_PIN), analogInputToDigitalPin(TEMP_2_PIN), analogInputToDigitalPin(TEMP_BED_PIN) }
#endif

